unit fFunc00000;// 3D r

interface

uses Windows, fFunc, OpenGL, GL, GLFont;

type
	TfrmFunc00000 = class(TfrmFunc)
  public
		Angle: Single;
  	FTexts: array[0..1] of TChineseFont;
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00000 }

procedure TfrmFunc00000.glDraw;
begin
	//M Screen & Depth Buffer
	glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);//Set Modelview Matrix

	glPushMatrix();

	glLoadIdentity();
	// move 10 units into the screen and rotate along all axes
 	Angle := Angle + 0.5;
	glTranslatef(0,1,-12.5);
	glRotatef(Angle,0,-1,0);  //Pitch,Turn,Roll

	//Display the FTexts[0]
	glColor3f(0,0,1);
	glScalef(1.5,2,1.5);
	FTexts[0].Draw();

  //Display the FTexts[1]
	glTranslatef(-3.5,-1,-1);
	glColor3f(1,1,0);
  glScalef(1,1,1);
	FTexts[1].Draw();

	glPopMatrix();

	FContext.PageFlip;
end;

procedure TfrmFunc00000.glInit;
var
	I: Integer;
begin
	for I := 0 to Length(FTexts)-1 do
  	case I of
    	0: FTexts[I] := TChineseFont.Create('Delphi K.Top');
			1: FTexts[I] := TChineseFont.Create('Qװ');
    end;
	glClearColor(0.0, 0.0, 0.0, 0.0);		// clear to black
	glShadeModel(GL_SMOOTH);						// use smooth shading
	glEnable(GL_DEPTH_TEST);						// hidden surface removal
	glEnable(GL_LIGHT0);								// enable light0
	glEnable(GL_LIGHTING);							// enable lighting
	glEnable(GL_COLOR_MATERIAL);				// enable color for material
  
end;

procedure TfrmFunc00000.glResize;
begin
  with FP do
  begin
    if (Height = 0) then Width := 1;			// don't want a divide by zero
    glViewport(0, 0, Width, Height);			// reset the viewport to new dimensions
    glMatrixMode(GL_PROJECTION);					// set projection matrix current matrix
    glLoadIdentity();											// reset projection matrix
    // calculate aspect ratio of window
    gluPerspective(54.0,Width/Height,1.0,1000.0);
    glMatrixMode(GL_MODELVIEW);						// set modelview matrix
    glLoadIdentity();											// reset modelview matrix
  end;
end;


end.

