unit fFunc00002;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00002 = class(TfrmFunc)
  public
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00002 }

procedure TfrmFunc00002.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 0.0); // Set the Background colour of or scene
  glLoadIdentity();                 // Load a "clean" model matrix on the stack
  glClear(GL_COLOR_BUFFER_BIT);     // Clear the colour buffer
  glTranslatef(0.0,0.0,-3.0);       // Move the scene back by 3 units (Will be explained in a later Chapter)
  glColor3f(1.0, 1.0, 1.0);         // Set the colour of the objects that will be dawn later
  glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0);
  glBegin(GL_POLYGON);              // begin drawing a polygon (Many pointed/ sided shape)
    glVertex2f(-0.5, -0.5);         // Draw a point (Two Dimentional Vertex)
    glVertex2f(-0.5, 0.5);
    glVertex2f(0.5, 0.5);
    glVertex2f(0.5, -0.5);
  glEnd();                          // End the shape
	FContext.PageFlip;
end;

procedure TfrmFunc00002.glResize;
begin
	if Assigned(FContext) then
  begin
    if FP.Height = 0 then FP.Height := 1;		// prevent divide by zero exception
    glViewport(0, 0, FP.Width, FP.Height);  // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        		// Change Matrix Mode to Projection
    glLoadIdentity();                   		// Reset View
    gluPerspective(45.0, FP.Width/FP.Height, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth
    glMatrixMode(GL_MODELVIEW);         		// Return to the modelview matrix
    glLoadIdentity();                   		// Reset View
  end;
end;

end.
