unit fFunc00003;

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00003 = class(TfrmFunc)
  public
    spin: GLfloat;
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00003 }

procedure TfrmFunc00003.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear(GL_COLOR_BUFFER_BIT);     // Clear the colour buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  spinDisplay(spin, 2.0);                    // Call this to find the next angle to rotate the scene by.
  glPushMatrix();                   // Make a copy of the current Model matrix and push it onto the stack
    glRotatef(spin, 0.0, 0.0, 1.0); // Rotate the the current matrix/scene ( Within the glPush/popMatrix)
    glRectf(-25.0, -25.0, 25.0, 25.0);
  glPopMatrix();                    // Pop the Current model matrix off the stack (Restoring the old matrix)

  glFlush();                        // Flush the OpenGL Buffer

	FContext.PageFlip;
  
end;

procedure TfrmFunc00003.glInit;
begin
	spin := 0.0;
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white
  glShadeModel(GL_FLAT);            // Use flat shading
end;

procedure TfrmFunc00003.glResize;
begin
  // This is one way to set the perspective when a window get resized.
  // But this is not the only way. Another way will be handled in a later tutorial
	with FP do
  begin
    glViewport(0, 0, Width, Height);                    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);                        // Change Matrix Mode to Projection
    glLoadIdentity();                                   // Reset View ( Load Thye default projection matrix onto the stack)
    if (Width <= Height) then glOrtho (-50.0, 50.0, -50.0*Height/Width, 50.0*Height/Width, -1.0, 1.0) // Set up orthographic view
    else											glOrtho (-50.0*Width/Height,50.0*Width/Height, -50.0, 50.0, -1.0, 1.0); // Set up orthographic view
    glMatrixMode(GL_MODELVIEW);                         // Return to the modelview matrix
    glLoadIdentity();                                  	// Reset View ( Load the default Modelview matrix onto the stack)
  end;

end;

end.
