unit fFunc00009;

interface

uses fFunc, fUtils, OpenGL, GL, Glut, Glaux, GLFont;

type
	TfrmFunc00009 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glFinal; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
	FBitmapFont: TChineseBmp;
  
implementation

{ TfrmFunc00009 }

procedure TfrmFunc00009.glDraw;
begin
	//M Screen & Depth Buffer
	glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
	if Assigned(FBitmapFont) then
  begin
		FBitmapFont.PrePrint();
    glColor3f(1,0,0);
		FBitmapFont.Print(12, 12, 'Delphi K.Top');
    glColor3f(0,1,0);
		FBitmapFont.Print(120, 12, 'Qװ');
		FBitmapFont.PostPrint();
  end;
	FContext.PageFlip;
end;

procedure TfrmFunc00009.glFinal;
begin
  FBitmapFont.Free;
end;

procedure TfrmFunc00009.glInit;
begin
	FBitmapFont := TChineseBmp.Create('DATA\FONT_GL.15');
	SetupPixelFormat(FP_HDC);
	glClearColor(0.0, 0.0, 0.0, 0.0);		// clear to black
	glShadeModel(GL_SMOOTH);						// use smooth shading
	glEnable(GL_DEPTH_TEST);						// hidden surface removal
	glEnable(GL_LIGHT0);								// enable light0
	glEnable(GL_LIGHTING);							// enable lighting
	glEnable(GL_COLOR_MATERIAL);				// enable color for material
end;

procedure TfrmFunc00009.glResize;
begin
	with FP do
  begin
    if (Height = 0) then Width := 1;			// don't want a divide by zero
    glViewport(0, 0, Width, Height);			// reset the viewport to new dimensions
		if Assigned(FBitmapFont) then
  		FBitmapFont.SetDisplayWH(Width, Height);
  end;
end;

end.

