unit fFunc00013;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00013 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00013 }

procedure TfrmFunc00013.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear (GL_COLOR_BUFFER_BIT);    // Clear the colour and depth buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); // Set The polygon mode to use lines to define the front and back of the polygon
                                             // If you arent going to draw primitives any other way, it is a good idea to add this in the glInit procedure
                                             // instead of making recursive calls to set the state to the same thing
  glBegin(GL_POLYGON);              // Start drawing the Polygon
      glEdgeFlag(GL_TRUE);          // Set Edgeflag to True, so we get a line from this vertex to the next
      glVertex3f(-12.0,-12.0,0.0);  // V0
      glEdgeFlag(GL_FALSE);         // Set Edgeflag to FALSE, so we no not get a line from this vertex to the next
      glVertex3f(12.0,-12.0,0.0);   // V1
      glEdgeFlag(GL_TRUE);          // Set Edgeflag to True, so we get a line from this vertex to the next
      glVertex3f(0.0,12.0,0.0);     // V2
  glEnd();
  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;
end;

procedure TfrmFunc00013.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white

  glShadeModel(GL_FLAT);            // Use flat shading

end;

procedure TfrmFunc00013.glResize;
begin
	with FP do
	begin
    // This is one way to set the perspective when a window get resized.
    // But this is not the only way. Another way will be handled in a later tutorial

    glViewport(0, 0, Width, Height);                    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);                        // Change Matrix Mode to Projection
    glLoadIdentity();                                   // Reset View ( Load Thye default projection matrix onto the stack)
    if (Width <= Height) then
        glOrtho (-50.0, 50.0, -50.0*Height/Width,
            50.0*Height/Width, -1.0, 1.0)               // Set up orthographic view
    else
        glOrtho (-50.0*Width/Height,
            50.0*Width/Height, -50.0, 50.0, -1.0, 1.0); // Set up orthographic view
    glMatrixMode(GL_MODELVIEW);                         // Return to the modelview matrix
    glLoadIdentity();                                  // Reset View ( Load the default Modelview matrix onto the stack)
  end;

end;

end.

