unit fFunc00019;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00019 = class(TfrmFunc)
  protected
		procedure DrawTriangle();
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by


implementation

{ TfrmFunc00019 }

procedure TfrmFunc00019.DrawTriangle;
begin
  glBegin(GL_LINE_LOOP);
    glVertex2f(-1.0,-1.0);               // Set the first point of the line loop in the scene (bottom left)
    glVertex2f( 1.0,-1.0);               // Set the second point in the scene (bottom right)
    glVertex2f( 0.0, 1.0);               // Top middle
  glEnd;
end;

procedure TfrmFunc00019.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear the colour and depth buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  glTranslatef(0.0,0.0,-3.0);      // Move the scene 10 units back ( it will be out of our view otherwise)
  glColor3f(1.0, 1.0, 1.0);         // Set colour to white
  DrawTriangle();                   // solid lines 

  glEnable(GL_LINE_STIPPLE);        // Enable line stippling
  glLineStipple(1, $F0F0);          // dashed lines
  glLoadIdentity();                 // Load a "clean" model matrix on the stack
  glTranslatef(-1.0, 0.0, -3.0);   // Move the scene 1 unit to the left and 10 back
  DrawTriangle();                   // Draw A Triangle with lines

  glLineStipple(1, $F00F);          // long dashed lines
  glLoadIdentity();                 // Load a "clean" model matrix on the stack
  glTranslatef(0.0,0.0,-3.0);      // Move the scene 10 units back
  glScalef(1.5, 0.5, 1.0);          // Make the Triangle Bigger
  DrawTriangle();                   // Draw A Triangle with lines

  glLineStipple(1, $8888);          // dotted lines
  glLoadIdentity();                 // Load a "clean" model matrix on the stack
  glTranslatef(0.0,0.0,-3.0);
  glRotatef (90.0, 0.0, 0.0, 1.0);  // Rotate the triangle by 90 Degrees on the z-axis
  DrawTriangle();                   // Draw A Triangle with lines
  glDisable(GL_LINE_STIPPLE);       // Disable Line stippling

  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
  FContext.PageFlip;
end;

procedure TfrmFunc00019.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white
  glEnable(GL_DEPTH_TEST);          // Enable Depth testing
  glDepthFunc(GL_LEQUAL);
  glShadeModel(GL_FLAT);            // Use Flat shading
end;

procedure TfrmFunc00019.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

end.

