unit fFunc00020;

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00020 = class(TfrmFunc)
  protected
  	procedure DrawWheel();
    procedure DrawBolt();
    procedure DrawWheelAndBolts(RightSide : boolean);
    procedure DrawCarBody();
    procedure DrawBodyAndWheelAndBolts();
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

implementation

{ TfrmFunc00020 }

procedure TfrmFunc00020.DrawBodyAndWheelAndBolts;
begin
   glColor3f(1.0,0.0,0.0);
   DrawCarBody();
   glPushMatrix();
      glTranslatef(-1.0,-0.5,1.01);                    // move to first wheel position
      DrawWheelAndBolts(True);
   glPopMatrix();
   glPushMatrix();
      glTranslatef(-1.0,-0.5,-1.01);                   // move to 2nd wheel position
      DrawWheelAndBolts(False);
   glPopMatrix();
   glPushMatrix();
      glTranslatef(1.0,-0.5,-1.01);                    // move to 3nd wheel position
      DrawWheelAndBolts(False);
   glPopMatrix();
   glPushMatrix();
      glTranslatef(1.0,-0.5,1.01);                     // move to 3nd wheel position
      DrawWheelAndBolts(True);
   glPopMatrix();
end;

procedure TfrmFunc00020.DrawBolt;
begin
 	DrawTriangleFan(6,0.05);
end;

procedure TfrmFunc00020.DrawCarBody;
begin
  glBegin(GL_QUADS);
    // Front Face
    glNormal3f( 0.0, 0.0, 1.0);
    glVertex3f(-2.0, -0.5,  1.0);
    glVertex3f( 2.0, -0.5,  1.0);
    glVertex3f( 2.0,  0.5,  1.0);
    glVertex3f(-2.0,  0.5,  1.0);
    // Back Face
    glNormal3f( 0.0, 0.0,-1.0);
    glVertex3f(-2.0, -0.5, -1.0);
    glVertex3f(-2.0,  0.5, -1.0);
    glVertex3f( 2.0,  0.5, -1.0);
    glVertex3f( 2.0, -0.5, -1.0);
    // Top Face
    glNormal3f( 0.0, 1.0, 0.0);
    glVertex3f(-2.0,  0.5, -1.0);
    glVertex3f(-2.0,  0.5,  1.0);
    glVertex3f( 2.0,  0.5,  1.0);
    glVertex3f( 2.0,  0.5, -1.0);
    // Bottom Face
    glNormal3f( 0.0,-1.0, 0.0);
    glVertex3f(-2.0, -0.5, -1.0);
    glVertex3f( 2.0, -0.5, -1.0);
    glVertex3f( 2.0, -0.5,  1.0);
    glVertex3f(-2.0, -0.5,  1.0);
    // Right face
    glNormal3f( 1.0, 0.0, 0.0);
    glVertex3f( 2.0, -0.5, -1.0);
    glVertex3f( 2.0,  0.5, -1.0);
    glVertex3f( 2.0,  0.5,  1.0);
    glVertex3f( 2.0, -0.5,  1.0);
    // Left Face
    glNormal3f(-2.0, 0.0, 0.0);
    glVertex3f(-2.0, -0.5, -1.0);
    glVertex3f(-2.0, -0.5,  1.0);
    glVertex3f(-2.0,  0.5,  1.0);
    glVertex3f(-2.0,  0.5, -1.0);

    // Cabin
    // Front Face
    glNormal3f( 0.0, 0.0, 1.0);
    glVertex3f(-0.5,  0.5,  1.0);
    glVertex3f( 0.5,  0.5,  1.0);
    glVertex3f( 0.5,  1.0,  1.0);
    glVertex3f(-0.5,  1.0,  1.0);
    // Back Face
    glNormal3f( 0.0, 0.0,-1.0);
    glVertex3f(-0.5,  0.5, -1.0);
    glVertex3f(-0.5,  1.0, -1.0);
    glVertex3f( 0.5,  1.0, -1.0);
    glVertex3f( 0.5,  0.5, -1.0);
    // Top Face
    glNormal3f( 0.0, 1.0, 0.0);
    glVertex3f(-0.5,  1.0, -1.0);
    glVertex3f(-0.5,  1.0,  1.0);
    glVertex3f( 0.5,  1.0,  1.0);
    glVertex3f( 0.5,  1.0, -1.0);

    // Right face
    glNormal3f( 1.0, 0.0, 0.0);
    glVertex3f( 0.5,  0.5, -1.0);
    glVertex3f( 0.5,  1.0, -1.0);
    glVertex3f( 0.5,  1.0,  1.0);
    glVertex3f( 0.5,  0.5,  1.0);
    // Left Face
    glNormal3f(-0.5, 0.0, 0.0);
    glVertex3f(-0.5,  0.5, -1.0);
    glVertex3f(-0.5,  0.5,  1.0);
    glVertex3f(-0.5,  1.0,  1.0);
    glVertex3f(-0.5,  1.0, -1.0);

  glEnd();

end;

procedure TfrmFunc00020.DrawWheel;
begin
	DrawTriangleFan(20,0.5);
end;

procedure TfrmFunc00020.DrawWheelAndBolts(RightSide: boolean);
var
	i: GLint;
begin
  glColor3f(0.5,0.5,0.5);
  DrawWheel();
  for i := 0 to 4 do
  begin
    glPushMatrix();
      glRotatef(72.0*i,0.0,0.0,1.0);
      if RightSide then
        glTranslatef(0.2,0.0,0.01)
      else
        glTranslatef(0.2,0.0,-0.01);
      glColor3f(0.3,0.3,0.3);
      DrawBolt();
    glPopMatrix();
  end;
end;

procedure TfrmFunc00020.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);    // Clear the colour and depth buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  glTranslatef(0.0,0.0,-7.0);      // Move the scene 10 units back ( it will be out of our view otherwise)
  glColor3f(1.0, 1.0, 1.0);         // Set colour to white
  SpinDisplay(spin,1);
  glRotatef(spin,1.0,1.0,0.0);
  DrawBodyAndWheelAndBolts();

  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;
end;

procedure TfrmFunc00020.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white
  glEnable(GL_DEPTH_TEST);          // Enable Depth testing
  glDepthFunc(GL_LEQUAL);
  glShadeModel(GL_FLAT);            // Use Flat shading
end;

procedure TfrmFunc00020.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

end.

