unit fFunc00021;

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00021 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

const
  // User Constants

  // Clipping planes
  eqn : array[0..3] of GLdouble = (0.0, 1.0, 0.0, 0.0);    // y < 0
  eqn2: array[0..3] of GLdouble = (1.0, 0.0, 0.0, 0.0);    // x < 0

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

  // Quadric for sphere ( Dont worry too much about this now we'll handle this later)
  SphereQuadratic : gluQuadricObj;

implementation

{ TfrmFunc00021 }

procedure TfrmFunc00021.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear (GL_COLOR_BUFFER_BIT);    // Clear the colour  buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  glTranslatef(0.0,0.0,-2.0);      // Move the scene 5 units back ( it will be directly on our camera and thus invisible)
  glColor3f (0.0, 1.0, 0.0);       // Set colour to green
  glPushMatrix();                  // Copy the curent matrix and add it to the stack
    glTranslatef (0.0, 0.0, -2.0); // Translate the scene back 5 units
    SpinDisplay(spin,2);
    glRotatef(spin,1.0,1.0,1.0);   //Rotate the scene on all axii
    glClipPlane (GL_CLIP_PLANE0, @eqn); // Assign the clipping plane 0
    glEnable (GL_CLIP_PLANE0);          // Enable Clipping plane 0
    glClipPlane (GL_CLIP_PLANE1, @eqn2);// Assign the clipping plane 1
    glEnable (GL_CLIP_PLANE1);          // Enable Clipping plane 1

    glRotatef (90.0, 1.0, 0.0, 0.0);    // Rotate the scene 90 Degrees on the x-axis
    gluSphere(SphereQuadratic, 1.0, 32, 32); // Render the sphere to the scene
  glPopMatrix();


  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;
end;

procedure TfrmFunc00021.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white
  glShadeModel(GL_FLAT);            // Use Flat shading

  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);  // Draw Both front and back facing polygons as lines

  // Generate a sphere using the OpenGL utility Library
  SphereQuadratic := gluNewQuadric();		       // Create A Pointer To The Quadric Object (Return 0 If No Memory) (NEW)
end;

procedure TfrmFunc00021.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 20.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

end.

