unit fFunc00022;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00022 = class(TfrmFunc)
  protected
    procedure DayAdd();
    procedure DaySubtract();
    procedure YearAdd();
    procedure YearSubtract();
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

  year: GLint = 0;
  day : GLint = 0;
  AutoRun : boolean = True;

  // Quadric for sphere ( Dont worry too much about this now we'll handle this later)
  SphereQuadratic : gluQuadricObj;
  
implementation

{ TfrmFunc00022 }

procedure TfrmFunc00022.DayAdd;
begin
	day := (day + 5) mod 360;
end;

procedure TfrmFunc00022.DaySubtract;
begin
 	day := (day - 5) mod 360;
end;

procedure TfrmFunc00022.YearAdd;
begin
 	year := (year + 1) mod 360;
end;

procedure TfrmFunc00022.YearSubtract;
begin
 	year := (year - 1) mod 360;
end;

procedure TfrmFunc00022.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glClear (GL_COLOR_BUFFER_BIT);    // Clear the colour  buffer
  glLoadIdentity();                 // Load a "clean" model matrix on the stack

  if AutoRun then
  begin
    DayAdd;
    YearAdd;
  end;

  glTranslatef(0,0.5,-5);      // Move the scene 5 units back ( it will be directly on our camera and thus invisible)
  glRotatef(45,1.0,0.0,0.0);
  glPushMatrix();                  // Copy the curent matrix and add it to the stack
    glColor3f (1.0, 1.0, 0.0);       // Set colour to green
    gluSphere(SphereQuadratic, 0.8, 32, 32);  // draw sun
    glRotatef(year, 0.0, 1.0, 0.0);
    glTranslatef (2.0, 0.0, 0.0);
    glRotatef(day, 0.0, 1.0, 0.0);
    glColor3f (0.0, 1.0, 0.0);       // Set colour to green
    gluSphere(SphereQuadratic, 0.3, 32, 32);  // draw smaller planet
  glPopMatrix();


  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
  FContext.PageFlip;
end;

procedure TfrmFunc00022.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glColor3f(1.0, 1.0, 1.0);         // Set the Polygon colour to white
  glShadeModel(GL_FLAT);            // Use Flat shading

  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);  // Draw Both front and back facing polygons as lines

  // Generate a sphere using the OpenGL utility Library
  SphereQuadratic := gluNewQuadric();		       // Create A Pointer To The Quadric Object (Return 0 If No Memory) (NEW)
  gluQuadricNormals(SphereQuadratic, GLU_SMOOTH);	       // Create Smooth Normals (NEW)
  gluQuadricTexture(SphereQuadratic, ByteBool(GL_TRUE));	       // Create Texture Coords (NEW)
end;

procedure TfrmFunc00022.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 20.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;


end.

