unit fFunc00026;

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00026 = class(TfrmFunc)
  protected
		procedure DrawLetter(Letter : array of  TCharCoord);
    procedure printStrokedString(s : PChar);
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

const
  // User Constants

  FONT_PT = 1;
  FONT_STROKE = 2;
  FONT_END = 3;

  Adata : array [0..7] of TCharCoord = (
    ( x: 0.0; y: 0.0; coordtype:FONT_PT),
    ( x: 0.0; y: 9.0; coordtype:FONT_PT),
    ( x: 1.0; y:10.0; coordtype:FONT_PT),
    ( x: 4.0; y:10.0; coordtype:FONT_PT),
    ( x: 5.0; y: 9.0; coordtype:FONT_PT),
    ( x: 5.0; y: 0.0; coordtype:FONT_STROKE),
    ( x: 0.0; y: 5.0; coordtype:FONT_PT),
    ( x: 5.0; y: 5.0; coordtype:FONT_END)
    );

  Edata : array [0..5] of TCharCoord = (
    ( x: 5.0; y: 0.0; coordtype:FONT_PT),
    ( x: 0.0; y: 0.0; coordtype:FONT_PT),
    ( x: 0.0; y:10.0; coordtype:FONT_PT),
    ( x: 5.0; y:10.0; coordtype:FONT_STROKE),
    ( x: 0.0; y: 5.0; coordtype:FONT_PT),
    ( x: 4.0; y: 5.0; coordtype:FONT_END)
    );


  Pdata : array [0..6] of TCharCoord = (
    ( x: 0.0; y: 0.0; coordtype:FONT_PT),
    ( x: 0.0; y:10.0; coordtype:FONT_PT),
    ( x: 4.0; y:10.0; coordtype:FONT_PT),
    ( x: 5.0; y: 9.0; coordtype:FONT_PT),
    ( x: 5.0; y: 6.0; coordtype:FONT_PT),
    ( x: 4.0; y: 5.0; coordtype:FONT_PT),
    ( x: 0.0; y: 5.0; coordtype:FONT_END)
    );

  Rdata : array [0..8] of TCharCoord = (
    ( x: 0.0; y: 0.0; coordtype:FONT_PT),
    ( x: 0.0; y:10.0; coordtype:FONT_PT),
    ( x: 4.0; y:10.0; coordtype:FONT_PT),
    ( x: 5.0; y: 9.0; coordtype:FONT_PT),
    ( x: 5.0; y: 6.0; coordtype:FONT_PT),
    ( x: 4.0; y: 5.0; coordtype:FONT_PT),
    ( x: 0.0; y: 5.0; coordtype:FONT_STROKE),
    ( x: 3.0; y: 5.0; coordtype:FONT_PT),
    ( x: 5.0; y: 0.0; coordtype:FONT_END)
    );
  Sdata : array [0..11] of TCharCoord = (
    ( x: 0.0; y: 1.0; coordtype:FONT_PT),
    ( x: 1.0; y: 0.0; coordtype:FONT_PT),
    ( x: 4.0; y: 0.0; coordtype:FONT_PT),
    ( x: 5.0; y: 1.0; coordtype:FONT_PT),
    ( x: 5.0; y: 4.0; coordtype:FONT_PT),
    ( x: 4.0; y: 5.0; coordtype:FONT_PT),
    ( x: 1.0; y: 5.0; coordtype:FONT_PT),
    ( x: 0.0; y: 6.0; coordtype:FONT_PT),
    ( x: 0.0; y: 9.0; coordtype:FONT_PT),
    ( x: 1.0; y:10.0; coordtype:FONT_PT),
    ( x: 4.0; y:10.0; coordtype:FONT_PT),
    ( x: 5.0; y: 9.0; coordtype:FONT_END)
    );

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

  base : GLuint;

  test1 : PChar = 'A SPARE SERAPE APPEARS AS';
  test2 : PChar = 'APES PREPARE RARE PEPPERS';

implementation

{ TfrmFunc00026 }

procedure TfrmFunc00026.DrawLetter(Letter : array of  TCharCoord);
var
	i: GLint;
begin
    glBegin(GL_LINE_STRIP);
    for i := low(Letter) to high(Letter) do
    begin
      case Letter[i].coordtype of
      FONT_PT: glVertex2f(Letter[i].x,Letter[i].y);
      FONT_STROKE:
        begin
              glVertex2f(Letter[i].x,Letter[i].y);
              glEnd();
              glBegin(GL_LINE_STRIP);
        end;
      FONT_END:
        begin
              glVertex2f(Letter[i].x,Letter[i].y);
              glEnd();
              glTranslatef(8.0, 0.0, 0.0);
        end;
      end;
    end;
end;

procedure TfrmFunc00026.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0);     // Black Background
  glClear (GL_COLOR_BUFFER_BIT);        // Clear the colour buffer
  glLoadIdentity();                     // Load a "clean" model matrix on the stack
  glTranslatef(-55.0,-10.0,-100.0);     // Move the scene back 10 units so we can see the arm properly

  glColor3f(1.0,0.0,0.0);               // Set our current rendering colour to red

  glPushMatrix();
    glScalef(0.5, 0.5, 0.5);
      glTranslatef(10.0, 30.0, 0.0);
      printStrokedString(test1);
    glPopMatrix();
    glPushMatrix();
      glScalef(0.5, 0.5, 0.5);
    glTranslatef(10.0, 13.0, 0.0);
    printStrokedString(test2);
  glPopMatrix();

  // Flush the OpenGL Buffer
  glFlush();                            // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;  
end;

procedure TfrmFunc00026.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glShadeModel(GL_FLAT);            // Use Flat shading

  base := glGenLists (128);

    glListBase(base);

    glNewList(base+ord('A'), GL_COMPILE);
      DrawLetter(Adata);
    glEndList();
    glNewList(base+ord('E'), GL_COMPILE);
      DrawLetter(Edata);
    glEndList();
    glNewList(base+ord('P'), GL_COMPILE);
      DrawLetter(Pdata);
    glEndList();
    glNewList(base+ord('R'), GL_COMPILE);
      DrawLetter(Rdata);
    glEndList();
    glNewList(base+ord('S'), GL_COMPILE);
      DrawLetter(Sdata);
    glEndList();
    glNewList(base+ord(' '), GL_COMPILE);
      glTranslatef(8.0, 0.0, 0.0);
    glEndList();


  // NB: In most cases you will create all Display Lists Here,
  // since creating them in the Render Loop
  // will defeat the point of using Display Lists. (No Performance Gain)

end;

procedure TfrmFunc00026.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 200.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

procedure TfrmFunc00026.printStrokedString(s: PChar);
var
	len: GLsizei;
begin
	len := Length(string(s));
  glCallLists(len, GL_BYTE, PGLbyte(s));
end;

end.

