unit fFunc00027;

interface

uses fFunc, fUtils, OpenGL, GL;

type
	TfrmFunc00027 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by
  
implementation

{ TfrmFunc00027 }

procedure TfrmFunc00027.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0);     // Black Background
  glClear (GL_COLOR_BUFFER_BIT);        // Clear the colour buffer
  glLoadIdentity();                     // Load a "clean" model matrix on the stack
  glTranslatef(0.0,0.2,-3.0);          // Move the scene back 10 units so we can see the triangle properly

  glColor3f(1.0,0.0,0.0);               // Set our current rendering colour to red

  SpinDisplay(spin, 1);
  glRotatef(spin,0.0,1.0,0.0);          // Rotate the scene on the y-axis 
  glBegin(GL_TRIANGLES);                // Begin Drawing A Triangle
    glColor3f (1.0, 0.0, 0.0);          // Set the colour to Red
    glVertex3f (0.0, 1.0, 0.0);         // Top Vertex of Triangle
    glColor3f (0.0, 1.0, 0.0);          // Set the colour to Blue
    glVertex3f (-1.0,-1.0, 0.0);        // Left Vertex of Triangle
    glColor3f (0.0, 0.0, 1.0);          // Set the colour to green
    glVertex3f (1.0,-1.0, 0.0);         // Right Vertex of the polygon
  glEnd();                              // Stop Drawing the Triangle

  // Flush the OpenGL Buffer
  glFlush();                            // ( Force the buffer to draw or send a network packet of commands in a networked system)
  FContext.PageFlip;
end;

procedure TfrmFunc00027.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0); // Black Background
  glShadeModel(GL_SMOOTH);          // Use Smooth shading ( This is the Default so we dont actually have to set it)
end;

procedure TfrmFunc00027.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 20.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View

  end;
end;

end.

