unit fFunc00034;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00034 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFunc00034 }

procedure TfrmFunc00034.glDraw;
begin
  glClearColor(0.0, 0.0, 0.0, 0.0); // Set the Background colour of or scene
  glLoadIdentity();                 // Load a "clean" model matrix on the stack
  glClear(GL_COLOR_BUFFER_BIT);     // Clear the colour buffer

  glTranslatef(-0.5,-0.5,-1.5);       // Reposition the scene

  glColor4f(1.0, 0.4, 0.0, 0.75);      // Set the colour to yellow
  glRectf(0.0, 0.0, 0.5, 1.0);         // Draw a rectangle

  glColor4f(0.0, 0.4, 1.0, 0.75);      // Set the colour to cyan
  glRectf(0.0, 0.0, 1.0, 0.5);         // Draw a rectangle

  // draw colored polygons in reverse order in upper right
  glColor4f (0.0, 0.4, 1.0, 0.75);      // Set the colour to cyan
  glRectf (0.5, 0.5, 1.0, 1.0);         // Draw a rectangle

  glColor4f (1.0, 0.4, 0.0, 0.75);      // Set the colour to yellow
  glRectf (0.5, 0.5, 1.0, 1.0);         // Draw a rectangle

    // Flush the OpenGL Buffer
  glFlush();                            // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;
end;

procedure TfrmFunc00034.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 0.0); 	               // Black Background
  glEnable(GL_BLEND);                                // Enable Blending
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); // Set the type of Blending we want
  // GL_SRC_ALPHA = Use the Alpha component of the source colour
  // GL_ONE_MINUS_SRC_ALPHA = Use 1 minus the Alpha component of the destination colour
  
  glShadeModel(GL_FLAT);                             // Set our polygon shading to flat-shaded
end;

procedure TfrmFunc00034.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45.0, Width/Height, 1.0, 100.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

end.

