unit fFunc00037;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00037 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

const
  // User Constants

   rasters : array[0..23] of GLubyte = (
	    $c0, $00, $c0, $00, $c0, $00, $c0, $00,
  	  $c0, $00, $ff, $00, $ff, $00, $c0, $00,
    	$c0, $00, $c0, $00, $ff, $c0, $ff, $c0);

var
  // User Variables

  spin : GLfloat = 0;              // Var used for the amount to rotate an object by

  // Fog Variables
  fogMode : GLint = GL_EXP;
  density : GLfloat;
  fogColor : array [0..3] of GLfloat = ( 0.4, 0.4, 0.4, 1);

   // Mouse
  MouseButton : Integer = -1;         // mouse button down
  xPos, yPos, zPos : glFloat;         // Location
  Xcoord, Ycoord, Zcoord : Integer;   // Mouse Coordinates
    
implementation

{ TfrmFunc00037 }

procedure TfrmFunc00037.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT);                     // Clear the  colour buffer
  glLoadIdentity;                                   // Load a new matrix onto the stack
  glTranslatef(0, 0,-1);                      // move the scene 10 unots back
  glColor3f(1, 1, 1);                         // Set the current primitive colour to white
  glRasterPos3f(0, 0, 0);                     // set our raster position to the middle of the scene
  glBitmap(10, 12, 0, 0, 12, 0, @rasters);  // Draw the raster / character
  glBitmap(10, 12, 0, 0, 12, 0, @rasters);  // Draw the raster / character
  glBitmap(10, 12, 0, 0, 12, 0, @rasters);  // Draw the raster / character
  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;
end;

procedure TfrmFunc00037.glInit;
begin
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);     // set the anignment of our bits
    glClearColor(0, 0, 0, 0);        // set the background colour to black
end;

procedure TfrmFunc00037.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(45, Width/Height, 1, 50);  // Do the perspective calculations. Last value = max clipping depth
    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
  end;
end;

end.

