unit fFunc00039;

interface

uses Math, fFunc, OpenGL, GL;

type
	TfrmFunc00039 = class(TfrmFunc)
  protected
	  procedure MakeCheckImage;
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

const
  // User Constants

  CHECK_IMAGE_WIDTH = 256;
  CHECK_IMAGE_HEIGHT = 256;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

   // Mouse
  MouseButton : Integer = -1;         // mouse button down
  xPos, yPos, zPos : glFloat;         // Location
  Xcoord, Ycoord, Zcoord : Integer;   // Mouse Coordinates

  CheckImage : array [0..CHECK_IMAGE_WIDTH-1] of array [0..CHECK_IMAGE_HEIGHT-1] of array[0..2] of GLubyte;


implementation

{ TfrmFunc00039 }

procedure TfrmFunc00039.MakeCheckImage;
var
  i, j, c: GLint;
  andIResult,andJResult: GLfloat;
begin
       for i := 0 to CHECK_IMAGE_WIDTH -1 do
       begin
        for j := 0 to CHECK_IMAGE_HEIGHT -1 do
        begin
            if((i and $8) = 0) then
               andIResult := 1.0
            else
               andIResult := 0.0;

            if((j and $8) = 0) then
               andJResult := 1.0
            else
               andJResult := 0.0;

            c := Round(Math.Power(andIResult,andJResult))*255;
            checkImage[i][j][0] := GLubyte(c);
            checkImage[i][j][1] := GLubyte(c);
            checkImage[i][j][2] := GLubyte(c);
       end;
    end;
end;

procedure TfrmFunc00039.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);         // Clear the colour and depth buffer
  glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0); glVertex3f(-2.0, -1.0, 0.0);       // Draw a vertex and assign texture coordinates to it
    glTexCoord2f(0.0, 1.0); glVertex3f(-2.0, 1.0, 0.0);        // Draw a vertex and assign texture coordinates to it
    glTexCoord2f(1.0, 1.0); glVertex3f(0.0, 1.0, 0.0);         // Draw a vertex and assign texture coordinates to it
    glTexCoord2f(1.0, 0.0); glVertex3f(0.0, -1.0, 0.0);        // Draw a vertex and assign texture coordinates to it

    glTexCoord2f(0.0, 0.0); glVertex3f(1.0, -1.0, 0.0);        // Draw a vertex and assign texture coordinates to it
    glTexCoord2f(0.0, 1.0); glVertex3f(1.0, 1.0, 0.0);         // Draw a vertex and assign texture coordinates to it
    glTexCoord2f(1.0, 1.0); glVertex3f(2.41421, 1.0, -1.41421);// Draw a vertex and assign texture coordinates to it
    glTexCoord2f(1.0, 0.0); glVertex3f(2.41421, -1.0,-1.41421);// Draw a vertex and assign texture coordinates to it
  glEnd();

  // Flush the OpenGL Buffer
  glFlush();                        // ( Force the buffer to draw or send a network packet of commands in a networked system)
	FContext.PageFlip;  
end;

procedure TfrmFunc00039.glInit;
begin
  glClearColor (0.0, 0.0, 0.0, 0.0);                           // Set the background colour to black
  glEnable(GL_DEPTH_TEST);                                     // Enable Depth Testing
  glDepthFunc(GL_LEQUAL);                                      // Set the Depth Function to Linear Equal 

  MakeCheckImage();                                            // Make the Checkerboard image
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);                       // Set the alignment for the image
  glTexImage2D(GL_TEXTURE_2D, 0, 3, CHECK_IMAGE_WIDTH,
      CHECK_IMAGE_HEIGHT, 0, GL_RGB, GL_UNSIGNED_BYTE,
      @checkImage[0][0][0]);                                   // Load the image into Texture memory
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP); // Clamp the image to the S coordinate
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP); // Clamp the image to the T coordinate
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
      GL_NEAREST);                                             // Set the Magnification filter to use the nearest polygon
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, 
      GL_NEAREST);                                             // Set the Minification filter to use the nearest polygon
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);    // Use the texture as a Decal
  glEnable(GL_TEXTURE_2D);                                     // Enable the 2D texture
  glShadeModel(GL_FLAT);                                       // Do not shade the model
end;

procedure TfrmFunc00039.glResize;
begin
	with FP do
  begin
    if (Height = 0) then                // prevent divide by zero exception
      Height := 1;
    glViewport(0, 0, Width, Height);    // Set the viewport for the OpenGL window
    glMatrixMode(GL_PROJECTION);        // Change Matrix Mode to Projection
    glLoadIdentity();                   // Reset View
    gluPerspective(60.0, Width/Height, 1.0, 10.0);  // Do the perspective calculations. Last value = max clipping depth

    glMatrixMode(GL_MODELVIEW);         // Return to the modelview matrix
    glLoadIdentity();                   // Reset View
     glTranslatef(0.0, 0.0,-2.5);

  end;
end;


end.

