unit fFunc00045;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00045 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

  SphereQuadric : GLUquadricObj;     // Quadric for our sphere

   // Mouse
  MouseButton : Integer = -1;         // mouse button down
  Xcoord, Ycoord : Integer;   // Mouse Coordinates

  // Control Point for Bezier Curve
  ctrlpoints : array [0..3] of array[0..2] of GLfloat = (
    (-4.0, -4.0, 0.0),
    (-2.0, 4.0, 0.0),
    ( 2.0, -4.0, 0.0),
    ( 4.0, 4.0, 0.0)
    );
  
implementation

{ TfrmFunc00045 }

procedure TfrmFunc00045.glDraw;
var
	i : GLint;
begin

    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);        // Clear the Depth And Colour Buffers
    glColor3f(1.0, 1.0, 1.0);                                   // Set the Primitive Colour to white
    glBegin(GL_LINE_STRIP);                                     // Start Drawing a Line Strip
        for i := 0 to 29 do
            glEvalCoord1f(i/29);                                // glEvalCoord1f() is just like using glVertex1f()
    glEnd();                                                    // Stop Drawing a Line Strip
    // The following code displays the control points as dots.
    glPointSize(5.0);                                           // Set the Poinjt Size to 5.0
    glColor3f(1.0, 1.0, 0.0);                                   // Set the primitive colour to Yellow
    glBegin(GL_POINTS);                                         // Start Drawing Points
        for i := 0 to 4 do
            glVertex3fv(@ctrlpoints[i][0]);                     // Draw a Point
    glEnd();                                                    // Stop Drawing Points
    glFlush();              // ( Force the buffer to draw or send a network packet of commands in a networked system)
		FContext.PageFlip;    
end;

procedure TfrmFunc00045.glInit;
begin
  glClearColor(0.0, 0.0, 0.0, 1.0);
  glMap1f(GL_MAP1_VERTEX_3, 0.0, 1.0, 3, 4,@ctrlpoints[0][0]);  // Add our control points for the bezier curves
  glEnable(GL_MAP1_VERTEX_3);                                   // Enable the one-dimensional evaluator for two-dimensional vertices.
  glShadeModel(GL_FLAT);                                        // Do not shade the primitives
end;

procedure TfrmFunc00045.glResize;
begin
	with FP do
  begin
    glViewport(0, 0, Width, Height);                              // Set our viewable area
    glMatrixMode(GL_PROJECTION);                                  // Switch to the projection matrix
    glLoadIdentity();                                             // Load a new Matrix onto the stack
    if (Width <= Height) then
        glOrtho(-5.0, 5.0, -5.0*Height/Width,5.0*Height/Width, -5.0, 5.0)
    else
        glOrtho(-5.0*Width/Height, 5.0*Width/Height, -5.0, 5.0, -5.0, 5.0);
    glMatrixMode(GL_MODELVIEW);                                   // Switch to Model View Matrix
    glLoadIdentity();                                             // Load a new Model View Matrix onto the stack
	end;    
end;

end.

