unit fFunc00046;

interface

uses fFunc, OpenGL, GL;

type
	TfrmFunc00046 = class(TfrmFunc)
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by


   // Mouse
  MouseButton : Integer = -1; // mouse button down
  Xcoord, Ycoord : Integer;   // Mouse Coordinates

  // Control Point for Bezier Surface
  ctrlpoints : array [0..3] of array [0..3] of array[0..2] of GLfloat = (
    ((-1.5, -1.5, 4.0), (-0.5, -1.5, 2.0),
     (0.5, -1.5, -1.0), (1.5, -1.5, 2.0)),
    ((-1.5, -0.5, 1.0), (-0.5, -0.5, 3.0),
      (0.5, -0.5, 0.0), (1.5, -0.5, -1.0)),
    ((-1.5, 0.5, 4.0), (-0.5, 0.5, 0.0),
      (0.5, 0.5, 3.0), (1.5, 0.5, 4.0)),
    ((-1.5, 1.5, -2.0), (-0.5, 1.5, -2.0),
      (0.5, 1.5, 0.0), (1.5, 1.5, -1.0))
  );

implementation

{ TfrmFunc00046 }

procedure TfrmFunc00046.glDraw;
var
	i, j : GLint;
begin
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);     // Clear the Colour and Depth buffer
    glColor3f(1.0, 1.0, 1.0);                                // Set the primitive Colour
    glPushMatrix();                                          // Push a new Matrix onto the stack
    glRotatef(85.0, 1.0, 1.0, 1.0);                          // Rotate the scene 85 degrees on all axis
    for j := 0 to 8 do                                       // Draw Vertical and Horizontal Lines
    begin
        glBegin(GL_LINE_STRIP);                              // Start Drawing A Line strip
            for i := 0 to 29 do                              // Draw Vertical Lines
                glEvalCoord2f(i/29.0, j/8.0);                // Evaluate the given coordinates u and v
        glEnd();                                             // Stop Drawing a line strip
        glBegin(GL_LINE_STRIP);                              // Start Drawing a line strip
            for i := 0 to 29 do                              // Draw Horizontal Lines
                glEvalCoord2f(j/8.0, i/29.0);                // Evaluate the given coordinates u and v
        glEnd();                                             // Stop Drawing a line strip
    end;
    glPopMatrix();                                           // Restore the Previous Matrix

    glFlush();              // ( Force the buffer to draw or send a network packet of commands in a networked system)
		FContext.PageFlip;    
end;


procedure TfrmFunc00046.glInit;
begin
  glClearColor (0.0, 0.0, 0.0, 1.0);                    // Set the Background colour
  glMap2f(GL_MAP2_VERTEX_3, 0, 1, 3, 4,
     0, 1, 12, 4, @ctrlpoints[0][0][0]);                // Set the control points for the Bezier Surface
  glEnable(GL_MAP2_VERTEX_3);                           // Enable Vertex Mapping
  glEnable(GL_DEPTH_TEST);                              // Enable Depth Testing
  glShadeModel(GL_FLAT);                                // Do Not shade the model
end;

procedure TfrmFunc00046.glResize;
begin
	with FP do
  begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    if (Width <= Height) then glOrtho(-3.15, 3.15, -3.15*Height/Width,3.15*Height/Width, -3.15, 3.15)
    else                      glOrtho(-3.15*Width/Height, 3.15*Width/Height, -3.15, 3.15, -3.15, 3.15);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
  end;
end;

end.

