unit fFunc00052;

interface

uses Classes, Controls, Math, SysUtils, fFunc, OpenGL, GL;

type
	TfrmFunc00052 = class(TfrmFunc)
  protected
		procedure MakeRasterFont;
    procedure glDrawText(SText : string; xPos,yPos : integer);
		procedure DrawSquares(mode : GLenum);
    procedure ProcessHits(hits : GLint; buffer : array of GLuint);
		procedure PickSquares();
		procedure DO_MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  public
    procedure glInit; override;
    procedure glDraw; override;
    procedure glResize; override;
  end;

const
  // User Constants

  // Definition of a complete font 
   rasters :array[0..94] of array[0..12] of GLubyte = (
    ($00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00),
    ($00, $00, $18, $18, $00, $00, $18, $18, $18, $18, $18, $18, $18),
    ($00, $00, $00, $00, $00, $00, $00, $00, $00, $36, $36, $36, $36),
    ($00, $00, $00, $66, $66, $ff, $66, $66, $ff, $66, $66, $00, $00),
    ($00, $00, $18, $7e, $ff, $1b, $1f, $7e, $f8, $d8, $ff, $7e, $18),
    ($00, $00, $0e, $1b, $db, $6e, $30, $18, $0c, $76, $db, $d8, $70),
    ($00, $00, $7f, $c6, $cf, $d8, $70, $70, $d8, $cc, $cc, $6c, $38),
    ($00, $00, $00, $00, $00, $00, $00, $00, $00, $18, $1c, $0c, $0e),
    ($00, $00, $0c, $18, $30, $30, $30, $30, $30, $30, $30, $18, $0c),
    ($00, $00, $30, $18, $0c, $0c, $0c, $0c, $0c, $0c, $0c, $18, $30),
    ($00, $00, $00, $00, $99, $5a, $3c, $ff, $3c, $5a, $99, $00, $00),
    ($00, $00, $00, $18, $18, $18, $ff, $ff, $18, $18, $18, $00, $00),
    ($00, $00, $30, $18, $1c, $1c, $00, $00, $00, $00, $00, $00, $00),
    ($00, $00, $00, $00, $00, $00, $ff, $ff, $00, $00, $00, $00, $00),
    ($00, $00, $00, $38, $38, $00, $00, $00, $00, $00, $00, $00, $00),
    ($00, $60, $60, $30, $30, $18, $18, $0c, $0c, $06, $06, $03, $03),
    ($00, $00, $3c, $66, $c3, $e3, $f3, $db, $cf, $c7, $c3, $66, $3c),
    ($00, $00, $7e, $18, $18, $18, $18, $18, $18, $18, $78, $38, $18),
    ($00, $00, $ff, $c0, $c0, $60, $30, $18, $0c, $06, $03, $e7, $7e),
    ($00, $00, $7e, $e7, $03, $03, $07, $7e, $07, $03, $03, $e7, $7e),
    ($00, $00, $0c, $0c, $0c, $0c, $0c, $ff, $cc, $6c, $3c, $1c, $0c),
    ($00, $00, $7e, $e7, $03, $03, $07, $fe, $c0, $c0, $c0, $c0, $ff),
    ($00, $00, $7e, $e7, $c3, $c3, $c7, $fe, $c0, $c0, $c0, $e7, $7e),
    ($00, $00, $30, $30, $30, $30, $18, $0c, $06, $03, $03, $03, $ff),
    ($00, $00, $7e, $e7, $c3, $c3, $e7, $7e, $e7, $c3, $c3, $e7, $7e),
    ($00, $00, $7e, $e7, $03, $03, $03, $7f, $e7, $c3, $c3, $e7, $7e),
    ($00, $00, $00, $38, $38, $00, $00, $38, $38, $00, $00, $00, $00),
    ($00, $00, $30, $18, $1c, $1c, $00, $00, $1c, $1c, $00, $00, $00),
    ($00, $00, $06, $0c, $18, $30, $60, $c0, $60, $30, $18, $0c, $06),
    ($00, $00, $00, $00, $ff, $ff, $00, $ff, $ff, $00, $00, $00, $00),
    ($00, $00, $60, $30, $18, $0c, $06, $03, $06, $0c, $18, $30, $60),
    ($00, $00, $18, $00, $00, $18, $18, $0c, $06, $03, $c3, $c3, $7e),
    ($00, $00, $3f, $60, $cf, $db, $d3, $dd, $c3, $7e, $00, $00, $00),
    ($00, $00, $c3, $c3, $c3, $c3, $ff, $c3, $c3, $c3, $66, $3c, $18),
    ($00, $00, $fe, $c7, $c3, $c3, $c7, $fe, $c7, $c3, $c3, $c7, $fe),
    ($00, $00, $7e, $e7, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $e7, $7e),
    ($00, $00, $fc, $ce, $c7, $c3, $c3, $c3, $c3, $c3, $c7, $ce, $fc),
    ($00, $00, $ff, $c0, $c0, $c0, $c0, $fc, $c0, $c0, $c0, $c0, $ff),
    ($00, $00, $c0, $c0, $c0, $c0, $c0, $c0, $fc, $c0, $c0, $c0, $ff),
    ($00, $00, $7e, $e7, $c3, $c3, $cf, $c0, $c0, $c0, $c0, $e7, $7e),
    ($00, $00, $c3, $c3, $c3, $c3, $c3, $ff, $c3, $c3, $c3, $c3, $c3),
    ($00, $00, $7e, $18, $18, $18, $18, $18, $18, $18, $18, $18, $7e),
    ($00, $00, $7c, $ee, $c6, $06, $06, $06, $06, $06, $06, $06, $06),
    ($00, $00, $c3, $c6, $cc, $d8, $f0, $e0, $f0, $d8, $cc, $c6, $c3),
    ($00, $00, $ff, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0, $c0),
    ($00, $00, $c3, $c3, $c3, $c3, $c3, $c3, $db, $ff, $ff, $e7, $c3),
    ($00, $00, $c7, $c7, $cf, $cf, $df, $db, $fb, $f3, $f3, $e3, $e3),
    ($00, $00, $7e, $e7, $c3, $c3, $c3, $c3, $c3, $c3, $c3, $e7, $7e),
    ($00, $00, $c0, $c0, $c0, $c0, $c0, $fe, $c7, $c3, $c3, $c7, $fe),
    ($00, $00, $3f, $6e, $df, $db, $c3, $c3, $c3, $c3, $c3, $66, $3c),
    ($00, $00, $c3, $c6, $cc, $d8, $f0, $fe, $c7, $c3, $c3, $c7, $fe),
    ($00, $00, $7e, $e7, $03, $03, $07, $7e, $e0, $c0, $c0, $e7, $7e),
    ($00, $00, $18, $18, $18, $18, $18, $18, $18, $18, $18, $18, $ff),
    ($00, $00, $7e, $e7, $c3, $c3, $c3, $c3, $c3, $c3, $c3, $c3, $c3),
    ($00, $00, $18, $3c, $3c, $66, $66, $c3, $c3, $c3, $c3, $c3, $c3),
    ($00, $00, $c3, $e7, $ff, $ff, $db, $db, $c3, $c3, $c3, $c3, $c3),
    ($00, $00, $c3, $66, $66, $3c, $3c, $18, $3c, $3c, $66, $66, $c3),
    ($00, $00, $18, $18, $18, $18, $18, $18, $3c, $3c, $66, $66, $c3),
    ($00, $00, $ff, $c0, $c0, $60, $30, $7e, $0c, $06, $03, $03, $ff),
    ($00, $00, $3c, $30, $30, $30, $30, $30, $30, $30, $30, $30, $3c),
    ($00, $03, $03, $06, $06, $0c, $0c, $18, $18, $30, $30, $60, $60),
    ($00, $00, $3c, $0c, $0c, $0c, $0c, $0c, $0c, $0c, $0c, $0c, $3c),
    ($00, $00, $00, $00, $00, $00, $00, $00, $00, $c3, $66, $3c, $18),
    ($ff, $ff, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00),
    ($00, $00, $00, $00, $00, $00, $00, $00, $00, $18, $38, $30, $70),
    ($00, $00, $7f, $c3, $c3, $7f, $03, $c3, $7e, $00, $00, $00, $00),
    ($00, $00, $fe, $c3, $c3, $c3, $c3, $fe, $c0, $c0, $c0, $c0, $c0),
    ($00, $00, $7e, $c3, $c0, $c0, $c0, $c3, $7e, $00, $00, $00, $00),
    ($00, $00, $7f, $c3, $c3, $c3, $c3, $7f, $03, $03, $03, $03, $03),
    ($00, $00, $7f, $c0, $c0, $fe, $c3, $c3, $7e, $00, $00, $00, $00),
    ($00, $00, $30, $30, $30, $30, $30, $fc, $30, $30, $30, $33, $1e),
    ($7e, $c3, $03, $03, $7f, $c3, $c3, $c3, $7e, $00, $00, $00, $00),
    ($00, $00, $c3, $c3, $c3, $c3, $c3, $c3, $fe, $c0, $c0, $c0, $c0),
    ($00, $00, $18, $18, $18, $18, $18, $18, $18, $00, $00, $18, $00),
    ($38, $6c, $0c, $0c, $0c, $0c, $0c, $0c, $0c, $00, $00, $0c, $00),
    ($00, $00, $c6, $cc, $f8, $f0, $d8, $cc, $c6, $c0, $c0, $c0, $c0),
    ($00, $00, $7e, $18, $18, $18, $18, $18, $18, $18, $18, $18, $78),
    ($00, $00, $db, $db, $db, $db, $db, $db, $fe, $00, $00, $00, $00),
    ($00, $00, $c6, $c6, $c6, $c6, $c6, $c6, $fc, $00, $00, $00, $00),
    ($00, $00, $7c, $c6, $c6, $c6, $c6, $c6, $7c, $00, $00, $00, $00),
    ($c0, $c0, $c0, $fe, $c3, $c3, $c3, $c3, $fe, $00, $00, $00, $00),
    ($03, $03, $03, $7f, $c3, $c3, $c3, $c3, $7f, $00, $00, $00, $00),
    ($00, $00, $c0, $c0, $c0, $c0, $c0, $e0, $fe, $00, $00, $00, $00),
    ($00, $00, $fe, $03, $03, $7e, $c0, $c0, $7f, $00, $00, $00, $00),
    ($00, $00, $1c, $36, $30, $30, $30, $30, $fc, $30, $30, $30, $00),
    ($00, $00, $7e, $c6, $c6, $c6, $c6, $c6, $c6, $00, $00, $00, $00),
    ($00, $00, $18, $3c, $3c, $66, $66, $c3, $c3, $00, $00, $00, $00),
    ($00, $00, $c3, $e7, $ff, $db, $c3, $c3, $c3, $00, $00, $00, $00),
    ($00, $00, $c3, $66, $3c, $18, $3c, $66, $c3, $00, $00, $00, $00),
    ($c0, $60, $60, $30, $18, $3c, $66, $66, $c3, $00, $00, $00, $00),
    ($00, $00, $ff, $60, $30, $18, $0c, $06, $ff, $00, $00, $00, $00),
    ($00, $00, $0f, $18, $18, $18, $38, $f0, $38, $18, $18, $18, $0f),
    ($18, $18, $18, $18, $18, $18, $18, $18, $18, $18, $18, $18, $18),
    ($00, $00, $f0, $18, $18, $18, $1c, $0f, $1c, $18, $18, $18, $f0),
    ($00, $00, $00, $00, $00, $00, $06, $8f, $f1, $60, $00, $00, $00)

);


  BUFSIZE = 512;                     // Size of the selection buffer

var
  // User Variables

  spin : GLfloat = 0.0;              // Var used for the amount to rotate an object by

   // Mouse
  MouseButton : Integer = -1;         // mouse button down
  Xcoord, Ycoord : Integer;   // Mouse Coordinates

  // Font
  fontOffset : GLuint;                // Offset for the Display list

  Output : array of string;           // Output string array for our text

  board : array [0..2] of array [0..2] of GLint;     // Amount of color for each square

  GWidth, GHeight : integer;          // Clobal Width and height of our window
  
implementation

{ TfrmFunc00052 }

procedure TfrmFunc00052.DO_MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	PickSquares();
end;

procedure TfrmFunc00052.DrawSquares(mode: GLenum);
var
	i, j : GLuint;
begin

    for i := 0 to 2 do                           // For each column
    begin
      if mode = GL_SELECT then glLoadName(i+1);  // Load a name
      for j := 0 to 2 do                         // For each Row
      begin
           if mode = GL_SELECT then
           begin
            glPushName(j+1);                     // Add the name to the object
           end;

           glColor3f ( i/3.0, j/3.0,board[i][j]/3.0); // Set the colour for the square
           glRecti (i, j, i+1, j+1);             // Draw the square
           if mode = GL_SELECT then glPopName;   // "Close" the named object
      end;
    end;
end;

procedure TfrmFunc00052.glDraw;
var i : GLint;
begin
  glClear(GL_COLOR_BUFFER_BIT);                                 // Clear the colour buffer

  DrawSquares(GL_RENDER);                                       // Render the scene
  for i := 0 to High(Output) do
  begin
    glDrawText(Output[i], 0, (50)+(14*i));                      // Print the text of any hits that occured
  end;
  glFlush();              // ( Force the buffer to draw or send a network packet of commands in a networked system)
  FContext.PageFlip;
end;

procedure TfrmFunc00052.glDrawText(SText: string; xPos, yPos: integer);
const
   RectOfs = 0;
begin
  glPushAttrib(GL_DEPTH_TEST);                                          // Save the current Depth test settings (Used for blending )
    glDisable(GL_DEPTH_TEST);                                           // Turn off depth testing (otherwise we get no FPS)
    glMatrixMode(GL_PROJECTION);                                        // Switch to the projection matrix
    glPushMatrix();                                                     // Save current projection matrix
      glLoadIdentity();

      glOrtho(0,GWidth, 0, GHeight, -1, 1);                             // Change the projection matrix using an orthographic projection
      glMatrixMode(GL_MODELVIEW);                                       // Return to the modelview matrix
      glPushMatrix();                                                   // Save the current modelview matrix
        glLoadIdentity();

        glColor3f(1.0,1.0,1.0);
        glRasterPos2i(xPos + RectOfs, GHeight - (yPos + RectOfs + 12)); // Position the Text
        glPushAttrib(GL_LIST_BIT);                                      // Save's the current base list
          glListBase(fontOffset);                                       // Set the base list to our character list
          glCallLists(length(SText), GL_UNSIGNED_BYTE,  PChar(SText));  // Display the text
        glPopAttrib();                                                  // Restore the old base list


        glMatrixMode(GL_PROJECTION);                                    // Switch to projection matrix
      glPopMatrix();                                                    // Restore the old projection matrix
      glMatrixMode(GL_MODELVIEW);                                       // Return to modelview matrix
    glPopMatrix();                                                      // Restore old modelview matrix
    glEnable(GL_DEPTH_TEST);
  glPopAttrib();                                                        // Restore depth testing;

  glResize;//(GWidth,GHeight);
end;

procedure TfrmFunc00052.glInit;
var
	i, j : GLint;
begin
	FP.OnMouseDown := DO_MouseDown;
  for i := 0 to 2 do
      for j := 0 to 2 do
          board[i][j] := 0;                       // Initialize the boards colour

  glClearColor (0.0, 0.0, 0.0, 0.0);              // Set the background colour to black

  MakeRasterFont();                                 // Initialize the raster font
end;

procedure TfrmFunc00052.glResize;
begin
	with FP do
  begin
    GWidth := Width;
    GHeight := Height;
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D (0.0, 3.0, 0.0, 3.0);
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	end;
end;

procedure TfrmFunc00052.MakeRasterFont;
var
	i : GLuint;
begin
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);      // set the bit alignment
    fontOffset := glGenLists (128);             // generate 128 display lists
    for i := 32 to 126 do
    begin
        glNewList(i+fontOffset, GL_COMPILE);    // Create but dont execute a list
            glBitmap(8, 13, 0.0, 2.0, 10.0, 0.0, @rasters[i-32]); // Add a character to the current Display list
        glEndList();                            // End the display list creation
    end;
end;

procedure TfrmFunc00052.PickSquares;
var selectBuf : array [0..BUFSIZE -1] of GLuint;
    hits : GLint;
    viewport : array [0..3] of GLint;
    x, y : GLint;
begin

    x := Xcoord;                                                 // Cet the current mouse coordinates
    y := Ycoord;

    glGetIntegerv (GL_VIEWPORT, @viewport);                      // Get the current viewport

    glSelectBuffer (BUFSIZE, @selectBuf);                        // Assign the selection buffer
    glRenderMode(GL_SELECT);                                     // Change the render mode to Selction Mode

    glInitNames();                                               // Init Names for Selection
    glPushName(0);                                               // Add the default name

    glMatrixMode (GL_PROJECTION);                                // Switch to Projection matrix/stack
    glPushMatrix();                                              // Load a new projection matrix onto the stack
        glLoadIdentity ();
        // Create 5x5 pixel picking region near cursor location
        gluPickMatrix(x, (viewport[3] - y), 5.0, 5.0, @viewport);
        gluOrtho2D (0.0, 3.0, 0.0, 3.0);
        DrawSquares (GL_SELECT);                                 // Draw squares in selection mode
    glPopMatrix();
    glFlush();                                                   // Force the render

    hits := glRenderMode(GL_RENDER);                             // Change back to Render mode and return any hits 
    processHits(hits, selectBuf);                                // Process all hits in the selection buffer
end;

procedure TfrmFunc00052.ProcessHits(hits: GLint; buffer: array of GLuint);
var
	i, j, ii, jj : Cardinal;
  names : GLuint;
  ptr : PGLuint;
begin
  SetLength(Output,1);
  Output[High(Output)] := 'Hits = ' + IntToStr(hits);
  ptr := @PGLuint(buffer[0]);
  for i := 0 to hits - 1 do // For each hit
  begin
      names := ptr^;
      SetLength(Output,Length(Output)+1);
      Output[High(Output)] := '  Number of names for hit '  + IntToStr(i+1) + ' = ' + IntToStr(names); Inc(ptr);
      SetLength(Output,Length(Output)+1);
      Output[High(Output)] := '  z1 is ' + FloatToStr(RoundTo(ptr^/$7fffffff,-2)); Inc(ptr);
      SetLength(Output,Length(Output)+1);
      Output[High(Output)] := '  z2 is ' + FloatToStr(RoundTo(ptr^/$7fffffff,-2)); Inc(ptr);
      SetLength(Output,Length(Output)+1);
      Output[High(Output)] := '  the name is ';
      ii := 0;
      jj := 0;
      for j := 0 to names - 1 do      // for each name
      begin
        Output[High(Output)] := Output[High(Output)] + IntToStr(ptr^)  + '.';
        if (j = 0) then  ii := ptr^ -1 //  set row and column  */
        else if (j  = 1) then jj := ptr^ - 1;
        Inc(ptr);
      end;
      board[ii][jj] := (board[ii][jj] + 1) mod 3;
  end;

end;

end.

