unit fFunc00057;

interface

uses Windows, SysUtils, fFuncNeHe, OpenGL, GL, GLaux;

type
	TfrmFunc00057 = class(TfrmFuncNeHe)
  protected
    function LoadGLTextures: Bool;
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;

var
  xrot: GLFloat;
  yrot: GLFloat;
  zrot: GLFloat;
  texture: array [0..0] of GLuint;
  
implementation

{ TfrmFunc00057 }

procedure TfrmFunc00057.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glTranslatef(0.0,0.0,-5.0);
  glRotatef(xrot,1.0,0.0,0.0);
  glRotatef(yrot,0.0,1.0,0.0);
  glRotatef(zrot,0.0,0.0,1.0);
  glBindTexture(GL_TEXTURE_2D,texture[0]);
  glBegin(GL_QUADS);

    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, 1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, 1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, 1.0);

    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0, 1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0, 1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);

    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, 1.0, 1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, 1.0, 1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, -1.0);

    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0, 1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0, 1.0);

    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, -1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f( 1.0, 1.0, 1.0);
    glTexCoord2f(0.0, 0.0); glVertex3f( 1.0, -1.0, 1.0);

    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
    glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, -1.0, 1.0);
    glTexCoord2f(1.0, 1.0); glVertex3f(-1.0, 1.0, 1.0);
    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, -1.0);
  glEnd();
  xrot := xrot + 0.3;
  yrot := yrot + 0.2;
  zrot := zrot + 0.4;

  FContext.PageFlip;

end;

procedure TfrmFunc00057.glInit;
begin
	inherited;
  glEnable(GL_TEXTURE_2D);
  LoadGLTextures;
end;

function TfrmFunc00057.LoadGLTextures: Bool;
var
  Status: Bool;
  BitmapFileName: string;
	TextureImage: array [0..0] of PTAUX_RGBImageRec;
begin
	BitmapFileName := 'DATA\walkway.bmp';
  Status := False;
  ZeroMemory(@TextureImage,sizeof(TextureImage));
  if FileExists(BitmapFileName) then
	  TextureImage[0] := LoadBMP(PChar(BitmapFileName));
  if Assigned(TextureImage[0]) then
    begin
    Status := True;
    glGenTextures(1,Texture[0]);
    glBindTexture(GL_TEXTURE_2D,texture[0]);
    glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0].sizeX,
    	TextureImage[0].sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[0].data);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    end;
  Result := Status;
end;

end.
