unit fFunc00058;

interface

uses Windows, fFuncNeHe, OpenGL, GL, GLaux;

const
  num = 20;

type
  stars = record
    r,g,b: integer;
    dist, angle: GLfloat;
  end;

	TfrmFunc00058 = class(TfrmFuncNeHe)
  protected
		function LoadGLTextures: Bool;
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

var
  twinkle: bool;
  tp: bool;
  star: array [0..num-1] of stars;
  zoom: GLfloat = -15.0;
  tilt: GLfloat = 90.0;
  spin: GLfloat;
  texture: array [0..0] of GLuint;
  
implementation

{ TfrmFunc00058 }

procedure TfrmFunc00058.glDraw;
var
	I: Integer;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glBindTexture(GL_TEXTURE_2D, texture[0]);
  for I := 0 to Length(star)-1 do
  begin
    glLoadIdentity();
    glTranslatef(0.0,0.0,zoom);
	  glRotatef(tilt,1.0,0.0,0.0);
	  glRotatef(star[I].angle,0.0,1.0,0.0);
    glTranslatef(star[I].dist,0.0,0.0);
    glRotatef(-star[I].angle, 0.0, 1.0, 0.0);
		glRotatef(-tilt, 1.0, 0.0, 0.0);
    if twinkle then
    begin
      glColor4ub(star[(num-I)-1].r,star[(num-I)-1].g,star[(num-I)-1].b,255);
      glBegin(GL_QUADS);
        glTexCoord2f(0.0, 0.0); glVertex3f(-1.0,-1.0, 0.0);
        glTexCoord2f(1.0, 0.0); glVertex3f( 1.0,-1.0, 0.0);
        glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, 0.0);
        glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, 0.0);
      glEnd();
    end;
    glRotatef(spin,0.0,0.0,1.0);
    glColor4ub(star[I].r,star[I].g,star[I].b,255);
    glBegin(GL_QUADS);
      glTexCoord2f(0.0, 0.0); glVertex3f(-1.0,-1.0, 0.0);
      glTexCoord2f(1.0, 0.0); glVertex3f( 1.0,-1.0, 0.0);
      glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, 0.0);
      glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, 0.0);
    glEnd();
    spin := spin + 0.01;
    star[I].angle := star[I].angle + I/num;
		star[I].dist := star[I].dist - 0.01;
    if star[I].dist < 0.0 then
    begin
        star[I].dist := star[I].dist + 5.0;
        star[I].r := Random(randseed) div 256;
        star[I].g := Random(randseed) div 256;
        star[I].b := Random(randseed) div 256;
    end;
  end;

  FContext.PageFlip;
  
end;

procedure TfrmFunc00058.glInit;
var
	I: Integer;
begin
  inherited;
  glDisable(GL_DEPTH_TEST);
  glEnable(GL_TEXTURE_2D);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);
  glEnable(GL_BLEND);
  RandSeed := GetTickCount();
  for I := 0 to Length(star)-1 do
  begin
    star[I].angle := 0.0;
    star[I].dist := I/num*5.0;
    star[I].r := Random(RandSeed) div 256;
    star[I].g := Random(RandSeed) div 256;
    star[I].b := Random(RandSeed) div 256;
  end;
  if not LoadGLTextures then EXIT;
end;

function TfrmFunc00058.LoadGLTextures: Bool;
var
	TextureImage: PTAUX_RGBImageRec;
  Status: Bool;
begin
  Status := False;
  ZeroMemory(@TextureImage,sizeof(TextureImage));
  TextureImage := LoadBMP('DATA\walkway.bmp');
  if Assigned(TextureImage) then
  begin
    Status := True;
    glGenTextures(1,@texture[0]);
    glBindTexture(GL_TEXTURE_2D,texture[0]);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage.sizeX,TextureImage.sizeY,
    	0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage.data);
  end;
  Result := Status;
end;

end.

