unit fFunc00059;

interface

uses Windows, fFuncNeHe, OpenGL, GL, GLaux;

type
	TfrmFunc00059 = class(TfrmFuncNeHe)
  protected
	  function LoadGLTextures: Bool;
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;

var
  xrot: GLFloat;
  yrot: GLFloat;
  zrot: GLFloat;
  texture: array [0..0] of GLuint;
  wiggle_count: integer = 0;
  hold: GLfloat;
  points: array [0..44,0..44,0..2] of GLfloat;  
  
implementation

{ TfrmFunc00059 }

procedure TfrmFunc00059.glDraw;
var
  x,y: integer;
  float_x,float_y,float_xb,float_yb: GLfloat;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glTranslatef(0.0,0.0,-12.0);
  glRotatef(xrot,1.0,0.0,0.0);
  glRotatef(yrot,0.0,1.0,0.0);
  glRotatef(zrot,0.0,0.0,1.0);
  glBindTexture(GL_TEXTURE_2D,texture[0]);
  glBegin(GL_QUADS);
    for x:=0 to 43 do
      for y:=0 to 43 do
      begin
        float_x := x/44;
        float_y := y/44;
        float_xb := (x+1)/44;
        float_yb := (y+1)/44;
        glTexCoord2f(float_x,float_y);
        glVertex3f(points[x,y,0],points[x,y,1],points[x,y,2]);
        glTexCoord2f(float_x,float_yb);
        glVertex3f(points[x,y+1,0],points[x,y+1,1],points[x,y+1,2]);
        glTexCoord2f(float_xb,float_yb);
        glVertex3f(points[x+1,y+1,0],points[x+1,y+1,1],points[x+1,y+1,2]);
        glTexCoord2f(float_xb,float_y);
        glVertex3f(points[x+1,y,0],points[x+1,y,1],points[x+1,y,2]);
      end;
  glEnd();
  if wiggle_count = 2 then
    begin
    for y := 0 to 44 do
      begin
      hold := points[0,y,2];
      for x := 0 to 43 do points[x,y,2] := points[x+1,y,2];
      points[44,y,2] := hold;
      end;
    wiggle_count := 0;
    end
    else wiggle_count := wiggle_count + 1;
  xrot := xrot + 0.3;
  yrot := yrot + 0.2;
  zrot := zrot + 0.4;

  FContext.PageFlip;

end;

procedure TfrmFunc00059.glInit;
var
	x, y: Integer;
begin
	inherited;
  glEnable(GL_TEXTURE_2D);
  glPolygonMode(GL_BACK, GL_FILL);
  glPolygonMode(GL_FRONT, GL_LINE);
  for x := 0 to 44 do
    for y:=0 to 44 do
    begin
      points[x,y,0] := x/5 - 4.5;
      points[x,y,1] := y/5 - 4.5;
      points[x,y,2] := sin((((x/5)*40)/360)*2*pi);
    end;
	if not LoadGLTextures then EXIT;
end;

function TfrmFunc00059.LoadGLTextures: Bool;
var
	TextureImage: array [0..0] of PTAUX_RGBImageRec;
  Status: Bool;
begin
  Status := False;
  ZeroMemory(@TextureImage,sizeof(TextureImage));
  TextureImage[0] := LoadBMP('DATA\tim.bmp');
  if Assigned(TextureImage[0]) then
    begin
    Status := true;
    glGenTextures(1,Texture[0]);
    glBindTexture(GL_TEXTURE_2D,texture[0]);
    glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[0].sizeX,TextureImage[0].sizeY,0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[0].data);    // Vlastn vytven textury
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    end;
  Result := Status;                                         
end;

end.

