unit fFunc00060;

interface

uses Windows, SysUtils, fFuncNeHe, OpenGL, GL, GLaux;

type
	TfrmFunc00060 = class(TfrmFuncNeHe)
  protected
		procedure BuildFont;
    procedure KillFont;
    procedure glPrint(Text: string);
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

var
  base: GLuint;
  cnt1, cnt2: GLfloat;
  
implementation

{ TfrmFunc00060 }

procedure TfrmFunc00060.BuildFont;
var
	Font: HFONT;
begin
  base := glGenLists(96);
  font := CreateFont(-36,
                      0,
                      0,
                      0,
                      FW_BOLD,
                      0,
                      0,
                      0,
                      ANSI_CHARSET,
                      OUT_TT_PRECIS,
                      CLIP_DEFAULT_PRECIS,
                      ANTIALIASED_QUALITY,
                      FF_DONTCARE or DEFAULT_PITCH,
                      'Courier New');
  SelectObject(FP_HDC,font);
  wglUseFontBitmaps(FP_HDC,32,96,base);                    
end;

procedure TfrmFunc00060.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);  // Smae obrazovku a hloubkov buffer
  glLoadIdentity();	                                    // Reset matice
  glTranslatef(0.0,0.0,-1.0);                           // Pesun o 1 do obrazovky
  glColor3f(1.0*cos(cnt1),1.0*sin(cnt2),1.0-0.5*cos(cnt1+cnt2));  // Pulzovn barev zvisl na pozici
  glRasterPos2f(-0.45+0.05*cos(cnt1), 0.32*(sin(cnt2)));          // Pozice textu
  glPrint(Format('Active OpenGL Text With NeHe - %7.2f',[cnt1])); // Vpis textu
  cnt1 := cnt1 + 0.051;
  cnt2 := cnt2 + 0.005;

  FContext.PageFlip;

end;

procedure TfrmFunc00060.glInit;
begin
  inherited;
  BuildFont;                     
end;

procedure TfrmFunc00060.glPrint(Text: string);
begin
  if Text = '' then EXIT;
  glPushAttrib(GL_LIST_BIT);
  glListBase(base - 32);
  glCallLists(length(text),GL_UNSIGNED_BYTE,Pchar(text));
  glPopAttrib;                                            
end;

procedure TfrmFunc00060.KillFont;
begin
	glDeleteLists(base,96);
end;

end.

