unit fFunc00061;

interface

uses Windows, SysUtils, fFuncNeHe, OpenGL, GL, GLaux;

type
	TfrmFunc00061 = class(TfrmFuncNeHe)
  protected
		procedure BuildFont;
    procedure KillFont;
    procedure glPrint(Text: string);
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

var
  base: GLuint;
  rot: GLfloat;
  gmf: array[0..255] of GLYPHMETRICSFLOAT; 

implementation

{ TfrmFunc00061 }

procedure TfrmFunc00061.BuildFont;
var
	Font: HFONT;
begin
  base := glGenLists(256);
  font := CreateFont(-48,
                      0,
                      0,
                      0,
                      FW_BOLD,
                      0,
                      0,
                      0,
                      ANSI_CHARSET,
                      OUT_TT_PRECIS,
                      CLIP_DEFAULT_PRECIS,
                      ANTIALIASED_QUALITY,
                      FF_DONTCARE or DEFAULT_PITCH,
                      'Courier New');

  SelectObject(FP_HDC,font);

  wglUseFontOutlines(FP_HDC,
                      0,
                      255,
                      base,
                      0,
                      0.2,
  	                  WGL_FONT_POLYGONS,
//                      WGL_FONT_LINES,
                      @gmf);
end;


procedure TfrmFunc00061.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glTranslatef(0.0,-1.0,-10.0);
  glColor3f(1.0*(cos(rot/20.0)),1.0*(sin(rot/25.0)),1.0-0.5*(cos(rot/17.0)));
{
  glRotatef(rot,1.0,0.0,0.0);
  glRotatef(rot*1.5,0.0,1.0,0.0);
  glRotatef(rot*1.4,0.0,0.0,1.0);
  glPrint(Format('NeHe - %3.2f',[rot/50]));
}
	glRotatef(rot,0.0,1.0,0.0);
  glScalef(4,4,4);
  glPrint('NeHe');// - %3.2f',[rot/50]));
  rot := rot + 1;

  FContext.PageFlip;

end;

procedure TfrmFunc00061.glInit;
begin
	inherited;
  glEnable(GL_LIGHT0);
  glEnable(GL_LIGHTING);
  glEnable(GL_COLOR_MATERIAL);
  BuildFont;                                         
end;

procedure TfrmFunc00061.glPrint(Text: string);
var
  I: Integer;
  delka: GLfloat;
begin
  if Text = '' then EXIT;
  delka := 0;
  for I:=1 to length(text)-1 do delka := delka + gmf[I].gmfCellIncX;
  glTranslatef(-delka/2,0.0,0.0);
  glPushAttrib(GL_LIST_BIT);
  glListBase(base);
  glCallLists(length(Text),GL_UNSIGNED_BYTE,Pchar(Text));
  glPopAttrib;
end;

procedure TfrmFunc00061.KillFont;
begin
 	glDeleteLists(base,256);
end;

end.

