unit fFunc00062;

interface

uses Windows, SysUtils, fFuncNeHe, OpenGL, GL, GLaux;

type
	TfrmFunc00062 = class(TfrmFuncNeHe)
  protected
		procedure BuildFont;
    procedure KillFont;
    procedure glPrint(x, y: Integer; Text: string; Sada: Integer);
	  function LoadGLTextures: Bool;
  public
    procedure glInit; override;
    procedure glDraw; override;
  end;

procedure glGenTextures(n: GLsizei; var textures: GLuint); stdcall; external opengl32;
procedure glBindTexture(target: GLenum; texture: GLuint); stdcall; external opengl32;

var
  base: Integer;
  texture: array[0..1] of GLuint;
  cnt1, cnt2: GLfloat;              

implementation

{ TfrmFunc00062 }

procedure TfrmFunc00062.BuildFont;
var
	I: Integer;
	cx, cy: GLfloat;
begin
  base := glGenLists(256);
  glBindTexture(GL_TEXTURE_2D,texture[0]);
  for I := 0 to 255 do
  begin
    cx := (I mod 16) / 16;
    cy := (I div 16) / 16;
    glNewList(base + I, GL_COMPILE);
      glBegin(GL_QUADS);
        glTexCoord2f(cx,1-cy-0.0625);glVertex2i(0,0);
        glTexCoord2f(cx+0.0625,1-cy-0.0625);glVertex2i(16,0);
        glTexCoord2f(cx+0.0625,1-cy);glVertex2i(16,16);
        glTexCoord2f(cx,1-cy);glVertex2i(0,16);
      glEnd;
      glTranslated(10,0,0);
    glEndList;
  end;
end;

procedure TfrmFunc00062.glDraw;
begin
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glBindTexture(GL_TEXTURE_2D,texture[1]);
  glTranslatef(0.0,0.0,-5.0);
  glRotatef(45.0,0.0,0.0,1.0);
  glRotatef(cnt1*30.0,1.0,1.0,0.0);
  glDisable(GL_BLEND);
  glColor3f(1.0,1.0,1.0);
  glBegin(GL_QUADS);
    glTexCoord2d(0.0,0.0);
    glVertex2f(-1.0, 1.0);
    glTexCoord2d(1.0,0.0);
    glVertex2f( 1.0, 1.0);
    glTexCoord2d(1.0,1.0);
    glVertex2f( 1.0,-1.0);
    glTexCoord2d(0.0,1.0);
    glVertex2f(-1.0,-1.0);
  glEnd();
  glRotatef(90.0,1.0,1.0,0.0);
  glBegin(GL_QUADS);
    glTexCoord2d(0.0,0.0);
    glVertex2f(-1.0, 1.0);
    glTexCoord2d(1.0,0.0);
    glVertex2f( 1.0, 1.0);
    glTexCoord2d(1.0,1.0);
    glVertex2f( 1.0,-1.0);
    glTexCoord2d(0.0,1.0);
    glVertex2f(-1.0,-1.0);
  glEnd();
  glEnable(GL_BLEND);
  glLoadIdentity();

  glColor3f(1.0*(cos(cnt1)),1.0*(sin(cnt2)),1.0-0.5*(cos(cnt1+cnt2)));
  glPrint(trunc((280+250*cos(cnt1))),trunc(235+200*sin(cnt2)),'NeHe',0);
  glColor3f(1.0*(sin(cnt2)),1.0-0.5*(cos(cnt1+cnt2)),1.0*(cos(cnt1)));
  glPrint(trunc((280+230*cos(cnt2))),trunc(235+200*sin(cnt1)),'OpenGL',1);
  glColor3f(0.0,0.0,1.0);
  glPrint(trunc(240+200*cos((cnt2+cnt1)/5)),2,'Giuseppe D''Agata',0);
  glColor3f(1.0,1.0,1.0);
  glPrint(trunc(242+200*cos((cnt2+cnt1)/5)),2,'Giuseppe D''Agata',0);
  cnt1 := cnt1 + 0.01;										
  cnt2 := cnt2 + 0.0081;

  FContext.PageFlip;

end;

procedure TfrmFunc00062.glInit;
begin
  if not LoadGLTextures then EXIT;
  BuildFont;
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glClearDepth(1.0);
  glDepthFunc(GL_LEQUAL);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE);
  glShadeModel(GL_SMOOTH);
  glEnable(GL_TEXTURE_2D);			                
end;

procedure TfrmFunc00062.glPrint(x, y: Integer; Text: string; Sada: Integer);
begin
  if Text = '' then EXIT;
  if Sada>1 then Sada:=1;
  glBindTexture(GL_TEXTURE_2D,texture[0]);
  glDisable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  glOrtho(0,640,0,480,-1,1);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glLoadIdentity;
  glTranslated(x,y,0);
  glListBase(base-32+(128*sada));
  glCallLists(length(text),GL_BYTE,Pchar(text));
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix;
  glEnable(GL_DEPTH_TEST);
end;

procedure TfrmFunc00062.KillFont;
begin
	glDeleteLists(base,256);
end;

function TfrmFunc00062.LoadGLTextures: Bool;
var
	I: Integer;
	TextureImage: array [0..1] of PTAUX_RGBImageRec;
  Status: Bool;
begin
  Status := False;
  ZeroMemory(@TextureImage,sizeof(TextureImage));
  TextureImage[0] := LoadBMP('C:\Font1.bmp');
  TextureImage[1] := LoadBMP('C:\walkway.bmp');
  if Assigned(TextureImage[0]) and Assigned(TextureImage[1]) then
    begin
    Status := true;
    glGenTextures(2,Texture[0]);
    for I := 0 to 1 do
      begin
      glBindTexture(GL_TEXTURE_2D,texture[I]);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
      glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[I].sizeX,TextureImage[I].sizeY,
      	0,GL_RGB,GL_UNSIGNED_BYTE,TextureImage[I].data);
      end;
    end;
  Result := Status;                                         
end;

end.

