unit fFunc;//DotContext

interface

uses
  Windows, Classes, Graphics, Controls, Forms, ExtCtrls, DotWindow, OpenGL, GL;

type
  TfrmFunc = class(TForm)
  private
    function GetFuncType: Integer;
  protected
  	FP: TPanel;
    FP_HDC: HDC;
  	FTimer: TTimer;
    FContext: TDotContext;
		procedure DO_FormClose(Sender: TObject; var Action: TCloseAction); virtual;
    procedure DO_FormPaint(Sender: TObject); virtual;
		procedure DO_FormResize(Sender: TObject); virtual;
    procedure DO_TimerTimer(Sender: TObject); virtual;
  public
  	constructor Create(AOwner: TComponent); override;
    procedure glInit(); virtual;
    procedure glFinal(); virtual;
    procedure glDraw(); virtual;
    procedure glResize(); virtual;
    property FuncType: Integer read GetFuncType;
  end;

implementation

{$R *.dfm}

uses SysUtils;

{ TfrmFunc }

constructor TfrmFunc.Create(AOwner: TComponent);
begin
  inherited;
  FP := TPanel.Create(Self);
  FP.Parent := TForm(Self);
  FP.Color := clBlack;
  FP.BevelInner := bvNone;
  FP.BevelOuter := bvNone;
  FP.Align := alClient;
  FP.Parent := TForm(Owner);
  FP_HDC := GetDC(FP.Handle);
  FContext := TDotContext.Create(FP_HDC,FALSE);
  if Assigned(FContext) then
  begin
  	FContext.InitGL;
    glClearColor(0,0,0,1);
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  end;
	FTimer := TTimer.Create(Self);
  FTimer.Interval := 1000;
  FTimer.OnTimer := DO_TimerTimer;
  OnClose := DO_FormClose;
  OnPaint := DO_FormPaint;
  OnResize := DO_FormResize;

 	glInit();

end;

procedure TfrmFunc.DO_FormClose(Sender: TObject; var Action: TCloseAction);
begin
	glFinal();
	if Assigned(FP) then
  	FP.Parent := TForm(Self);
	FreeAndNil(FContext);
	FreeAndNil(FTimer);
  FreeAndNil(FP);
  Action := caFree;
end;

procedure TfrmFunc.DO_FormPaint(Sender: TObject);
begin
	if Assigned(FContext) then glDraw();
end;

procedure TfrmFunc.DO_FormResize(Sender: TObject);
begin
	if Assigned(FContext) then glResize();
end;

procedure TfrmFunc.DO_TimerTimer(Sender: TObject);
begin
	TForm(Owner).Caption := ClassName;
end;

function TfrmFunc.GetFuncType: Integer;
begin
	Result := StrToInt(Copy(ClassName, 9, 5));
end;

procedure TfrmFunc.glInit();  begin{}end;
procedure TfrmFunc.glDraw();  begin{}end;
procedure TfrmFunc.glFinal();	begin{}end;
procedure TfrmFunc.glResize();begin{}end;

end.
