unit fFuncNeHe;

interface

uses Windows, SysUtils, fFunc, OpenGL, GLAux;

type
	TfrmFuncNeHe = class(TfrmFunc)
  protected
	  function LoadBMP(FileName: pchar):PTAUX_RGBImageRec;
  public
    procedure glInit; override;
    procedure glResize; override;
  end;

implementation

{ TfrmFuncNeHe }

procedure TfrmFuncNeHe.glInit;
begin
  glShadeModel(GL_SMOOTH);			                    // Enables Smooth Shading
  glClearColor(0.0, 0.0, 0.0, 0.5);	  	            // ¦I, Black Background
  glClearDepth(1.0);				                        // Depth Buffer Setup
  glEnable(GL_DEPTH_TEST);			                    // Enables Depth Testing
  glDepthFunc(GL_LEQUAL);				                    // The Type Of Depth Test To Do
  glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST); // Really Nice Perspective Calculations
end;

procedure TfrmFuncNeHe.glResize;
begin
	with FP do
  begin
    if (Height=0) then Height:=1; 		                      // Prevent A Divide By Zero By
                                                            // Making Height Equal One
    glViewport(0, 0, Width, Height);                        // Reset The Current Viewport
    glMatrixMode(GL_PROJECTION);                            // Select The Projection Matrix
    glLoadIdentity();                                       // Reset The Projection Matrix
    gluPerspective(45.0,Width/Height,0.1,100.0);            // Calculate The Aspect Ratio Of The Window
    glMatrixMode(GL_MODELVIEW);                             // Select The Modelview Matrix
    glLoadIdentity;                                         // Reset The Modelview Matrix
  end;
end;

function TfrmFuncNeHe.LoadBMP(FileName: pchar): PTAUX_RGBImageRec;
begin
	Result := nil;
  if Filename = '' then EXIT;
  if not FileExists(Filename) then EXIT;
  Result := auxDIBImageLoadA(FileName);
end;

end.

